﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices; // DLL Import







namespace GetString
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        [StructLayout(LayoutKind.Sequential)]
        public struct RECT
        {
            public int left;
            public int top;
            public int right;
            public int bottom;
        }

        //---------------------------------------------------------------
        // Win32API
        //---------------------------------------------------------------
        // 座標からウインドウのハンドルを取得する。
        [DllImport("user32.dll")]
        private static extern IntPtr WindowFromPoint(Point Point);

        //現在のマウスポインタ座標を取得 
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool GetCursorPos(out Point Point);

        //クラス名
        [DllImport("User32.Dll")]
        private static extern int GetClassName(int hwnd,
        [MarshalAs(UnmanagedType.LPStr)] StringBuilder strBuf, int nMaxCount);
        
        //親ウィンドウ
        [DllImport("User32.Dll")]
        static extern IntPtr GetParent(IntPtr hWnd);

        //キー押下状態
        [DllImport("user32.dll")]
        private static extern int GetAsyncKeyState(Keys vKeys);


        //---------------------------------------------------------------
        // GetText.DLL の宣言と関数定義
        //---------------------------------------------------------------
        //-------------------------------------------------------------
        // 定数宣言
        //-------------------------------------------------------------

        // 文字情報　GetAccInfo のパラメータ item
        const int GS_ACC_INFO_NAME = 1;	        // AccName
        const int GS_ACC_INFO_VALUE = 2;	    // AccValue
        const int GS_ACC_INFO_DESCRIPTION = 3;	// AccDescription
        const int GS_ACC_INFO_DEFAULTACTION = 4;// AccDefaultAction

        // 数値情報　GetAccNum のパラメータ item
        const int GS_ACC_NUM_ROLE = 1;		    // AccRole
        const int GS_ACC_NUM_STATE = 2;		    // AccState
        const int GS_ACC_NUM_CHILDCOUNT = 3;	// AccChildCount
        const int GS_ACC_NUM_LOCATION = 4;		// AccLocation
        const int GS_ACC_NUM_ID = 5;		    // ID
        //-------------------------------------------------------

        //---------------------------------------------------------------
        // ポイント直下の文字列取得
        //--------------------------------------
        // x,y      : スクリーン座標（Pixcel）
        // lpString : 文字列格納バッファアドレス
        // nMaxCount: バッファサイズ
        //
        // 返却値   : 0:正常　-1:取得失敗　-2:バッファサイズオーバー

        [DllImport("GetText.Dll")]
        private static extern int GetText(int x, int y,
        [MarshalAs(UnmanagedType.LPStr)] StringBuilder strBuf, int nMaxCount);


        //---------------------------------------------------------------
        // ポイント直下の全体文字列取得
        //--------------------------------------
        // x,y      : スクリーン座標（Pixcel）
        // lpString : 文字列格納バッファアドレス
        // nMaxCount: バッファサイズ
        //
        // 返却値   : 0:正常　-1:取得失敗　-2:バッファサイズオーバー

        [DllImport("GetText.Dll")]
        private static extern int GetFullText(int x, int y,
        [MarshalAs(UnmanagedType.LPStr)] StringBuilder strBuf, int nMaxCount);


        //---------------------------------------------------------------
        // ウィンドウステータスバーの文字列取得
        //--------------------------------------
        // x,y      : スクリーン座標（Pixcel）
        // lpString : 文字列格納バッファアドレス
        // nMaxCount: バッファサイズ
        //
        // 返却値   : 0:正常　-1:取得失敗　-2:バッファサイズオーバー

        [DllImport("GetText.Dll")]
        private static extern int GetStatusText(int x, int y,
        [MarshalAs(UnmanagedType.LPStr)] StringBuilder strBuf, int nMaxCount);

        //---------------------------------------------------------------
        // MSAA(Microsoft Active Accessibility)文字情報取得
        //
        // x,y      : スクリーン座標（Pixcel）
        // strBuf   : 文字列格納バッファアドレス
        // nMaxCount: バッファサイズ
        // item     : 取得情報種別　上記の「パラメータ値定義」参照
        //
        // 返却値   : 0:正常　-1:取得失敗　-2:バッファサイズオーバー
        //---------------------------------------------------------------

        [DllImport("GetText.Dll")]
        private static extern int GetAccInfo(int x, int y,
        [MarshalAs(UnmanagedType.LPStr)] StringBuilder strBuf, int nMaxCount, int item);


        //-------------------------------------------------------------
        // MSAA　数値情報取得
        //-------------------------------------------------------------
        //
        // x,y      : スクリーン座標（Pixcel）
        // item     : 取得情報種別　上記の「パラメータ値定義」参照
        //
        // 返却値   : >=0:数値情報　-1:取得失敗　-2:バッファサイズオーバー

        [DllImport("GetText.Dll")]
        private static extern int GetAccNum(int x, int y, int item);


        //-------------------------------------------------------------
        // MSAA　オブジェクト位置取得
        //-------------------------------------------------------------
        //
        // x,y      : スクリーン座標（Pixcel）
        // pxLeft,pxTop,pxWidth,pxHeight
        //          : 位置情報　それそれ
        //              　左位置、上位置、幅、高さ（Pixcel）がセットされる
        // 返却値   : 0:正常　-1:取得失敗　-2:バッファサイズオーバー

        [DllImport("GetText.Dll")]
        private static extern int GetAccLocation(int x, int y, ref RECT rec);


        //-------------------------------------------------------------
        // Role値を文字列に変換
        //-------------------------------------------------------------
        //
        // Role     : GetAccNum で取得した値
        // strBuf   : 文字列格納バッファアドレス
        // nMaxCount: バッファサイズ
        //
        // 返却値   : 0:正常　-1:取得失敗　-2:バッファサイズオーバー

        [DllImport("GetText.Dll")]
        private static extern int GetAccRoleText(int Role,
        [MarshalAs(UnmanagedType.LPStr)] StringBuilder strBuf, int nMaxCount);


        //-------------------------------------------------------------
        // オブジェクト種別取得
        //-------------------------------------------------------------
        //
        // x,y      : スクリーン座標（Pixcel）
        //
        // 返却値   : -1:取得失敗　0:不明　1:Simple Element 2:Real Object 3:Container

        [DllImport("GetText.Dll")]
        private static extern int GetObjType(int x, int y);


        //-------------------------------------------------------------
        // ライセンスキー登録
        //-------------------------------------------------------------
        //
        // 返却値   : 0:登録成功　-1:失敗　-2:不正ライセンス

        [DllImport("GetText.Dll")]
        private static extern int RegistKey(string key);

        //-------------------------------------------------------------

        bool LoopSw=false;  //ループスイッチ
        Point pos_pre;	    //前回のマウス位置
        int got_time;	    //取得した時間
        bool got;		    //取得済みか？

        private void btnGo_Click(object sender, EventArgs e){

            if(LoopSw == true){
                LoopSw = false;
            }else{

                /* 取得条件
                  ・マウスが移動中では無いこと
                ・自分のフォーム上では無いこと
                   ・マウスが０．５秒以上停止したら一回だけ取得
                */

                this.Text = "ＥＳＣで停止";
                btnGo.Text = "停止";
                LoopSw = true;
                GetAsyncKeyState(Keys.Escape); //空読み

                while (LoopSw)
                {
                    StringBuilder strBuf = new StringBuilder(4096);

                    bool skip = false;
                    int t=0;

                    //マウスポインタ位置
                    Point pos = new Point(), p;
                    GetCursorPos(out pos);
                    p = pos_pre;
                    if ((pos != pos_pre))
                    {	//移動中
                        pos_pre = pos;
                        lblMousePos.Text = String.Format("{0},{1}", pos.X, pos.Y);
                        got = false;							//未取得
                        skip = true;
                    }else{
                        t = System.Environment.TickCount;

                        if(got || (t < (got_time + 500)))	// 取得済み and 0.5秒未満の停止
                            skip = true;
                    }
                    if (!skip){

                    }
                    
                    //ウィンドウハンドル
                    IntPtr hWnd, phWnd = IntPtr.Zero, tmp_hWnd;
                    hWnd= WindowFromPoint(pos);
                    lblhWnd.Text = String.Format("{0}", hWnd);

                    //クラス名
                    GetClassName((int)hWnd, strBuf, strBuf.Capacity);
                    lblClassName.Text = strBuf.ToString();

                    tmp_hWnd = GetParent(hWnd);         //親ウィンドウ
                    while (tmp_hWnd != IntPtr.Zero){    //最上位ウィンドウを探す
                        phWnd = tmp_hWnd;
                        tmp_hWnd = GetParent(tmp_hWnd);
                    }
                    if (phWnd == this.Handle)   //自ウィンドウは撮らない
                        skip = true;

                    if (!skip)
                    {

                        lblStatus.Text = "取得中・・";
                        System.Windows.Forms.Application.DoEvents();

                        got_time = t; //退避                   


                        //ポインタ位置のテキスト
                        GetText(pos.X, pos.Y, strBuf, strBuf.Capacity);
                        txtText.Text = strBuf.ToString();

                        //ポインタ位置の全テキスト
                        GetFullText(pos.X, pos.Y, strBuf, strBuf.Capacity);
                        txtFullText.Text = strBuf.ToString();

                        //-----------------------------------------------

                        RECT rec = new RECT();
                        int Role;
                        string ObjType, Dt = "";

                        //位置情報
                        GetAccLocation(pos.X, pos.Y, ref rec);

                        Role = GetAccNum(pos.X, pos.Y, GS_ACC_NUM_ROLE);
                        switch (GetObjType(pos.X, pos.Y))
                        {
                            case 1:  ObjType = "Simple Element"; break;
                            case 2:  ObjType = "Real Object"; break;
                            case 3:  ObjType = "Container"; break;
                            default: ObjType = ""; break;
                        }

                        GetAccInfo(pos.X, pos.Y, strBuf, strBuf.Capacity, GS_ACC_INFO_NAME);
                        Dt += "Name        : " + strBuf.ToString() + "\r\n";
                        GetAccInfo(pos.X, pos.Y, strBuf, strBuf.Capacity, GS_ACC_INFO_VALUE);
                        Dt += "Value       : " + strBuf.ToString() + "\r\n";
                        GetAccRoleText(Role, strBuf, strBuf.Capacity);
                        Dt += "Role        : " + strBuf.ToString() + "\r\n";
                        Dt += "State       : " + String.Format("{0:x}", GetAccNum(pos.X, pos.Y, GS_ACC_NUM_STATE)) + "\r\n";
                        Dt += "Location    : " + String.Format("{0},{1},{2},{3}", rec.left, rec.top, rec.right, rec.bottom) + "\r\n";
                        GetAccInfo(pos.X, pos.Y, strBuf, strBuf.Capacity, GS_ACC_INFO_DEFAULTACTION);
                        Dt += "DefAction   : " + strBuf.ToString() + "\r\n";
                        Dt += "ChildCount  : " + String.Format("{0:x}", GetAccNum(pos.X, pos.Y, GS_ACC_NUM_CHILDCOUNT)) + "\r\n";
                        GetAccInfo(pos.X, pos.Y, strBuf, strBuf.Capacity, GS_ACC_INFO_DESCRIPTION);
                        Dt += "Description : " + strBuf.ToString() + "\r\n";
                        Dt += "ObjectType  : " + ObjType + "\r\n";
                        Dt += "ID          : " + String.Format("{0:d}", GetAccNum(pos.X, pos.Y, GS_ACC_NUM_ID)) + "\r\n";

                        txtAccInfo.Text = Dt;

                        //ウィンドウのステータスバーテキスト
                        GetStatusText(pos.X, pos.Y, strBuf, strBuf.Capacity);
                        txtStatusText.Text = strBuf.ToString();


                        lblStatus.Text = "";

                        got = true; //取得済み	

                    }
                    System.Threading.Thread.Sleep(50);
                    System.Windows.Forms.Application.DoEvents();

                    if (GetAsyncKeyState(Keys.Escape) != 0)
                        LoopSw = false;
                }
                btnGo.Text = "開始";
                this.Text = "GetString";
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //表示文字初期化
            lblMousePos.Text = "";
            lblhWnd.Text = "";
            lblClassName.Text = "";
            lblStatus.Text = "";
            txtText.Text = "";
            txtFullText.Text = "";
            txtAccInfo.Text = "";
            txtStatusText.Text = "";

            //----------------------------------------------------
            //ライセンスキーを登録します
            //----------------------------------------------------
            int rc;
            string key = "xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx";
            rc = RegistKey(key);
        }

        private void Form1_FormClosing(object sender, FormClosedEventArgs e)
        {
            LoopSw = false;
        }

    }
}
